<?php
/**
 CONFIGURA LES OPCIONS DEL BOT_PLUS AMB LES INDICACIONS DELS COMENTARIS
**/

// Opcions de bot_plus
// temps d'espera entre publicacions de les noticies (en segons) (a sumar al mínim de 30 segons)
$espera_tut = 29;

// Vols etiquetes? (Escriu 0 per a NO i 1 per al si)
$act_etiquetes = 1;

// Vols que el bot done la benvinguda als seguidors? (Escriu 0 per a NO i 1 per al si)
$act_bencom = 1;
// visib_tut de la benvinguda i el de comiat.
// Possibles valors: public, unlisted, private, direct (preferible les dos darreres)
$visib_benv = "direct";
$visib_comi = "direct";

// vols que el bot celebre les desenes i centenars de seguidors? (0 = NO, 1 = SI)
$act_cents = 1;
// visib_tut del missatge de centenars i desenes
$visib_cent = "public";

//Vols que el bot conteste les mencions? (Escriu 0 per a NO i 1 per al SI)
$act_mencio = 1;
//Vols que el bot conteste les mencions amb un missatge de resposta? (Escriu 0 per a NO i 1 per al SI)
$act_mencio_resp = 0;
// visib_tut de la resposta a les mencions
$visib_mencs = "unlisted";

// Vols que faça comentaris als seguidors
$act_coment = 1;
// Temps d'inactivitat per activar els comentaris (canviar només el nombre)
$espera_coment  = "8 hours";
// temps d'espera entre comentaris (canviar només el nombre)
$espera_coment2 = "2 hours";
// visib_tut dels comentaris (preferiblement private o direct) (Opcions: public, unlisted, private o direct)
$visib_com = "unlisted";

// Vols que envie un missatge pels impulsos
$act_impuls = 1;
//$act_impulsos = 1;

// Vols que envie un missatge als usuaris
$act_impuls_usu = 1;
// Vols que faça un tut indicant el tut més impulsat?
$act_impuls_resum = 1;
// Temps d'espera per fer el recull dels impulsos
$espera_impuls_resum = "1 week";
// visib_tut del missatge d'agraïment pels impulsos i els favorits. (Opcions: public, unlisted, private o direct)
$visib_imp_usu = "direct";
// visib_tut del missatge d'estadístiques dels impulsos i els favorits. (Opcions: public, unlisted, private o direct)
$visib_imp_res = "public";

// activar i definir parametres del tut d'errada
$errada_tut = 1;
$errada_vis = "private";

// continguts que vols que presente
// quantitat de paraules a filtrar (de 0 -no enfiltrarà cap- a 5);
$num_par = 5;

// escriu les paraules per les quals filtrarà les URL que vols arreplegar (fins a 10)
// estes estan a la RSS d'apuntmedia.es
$p0 = "cultura";
$p1 = "oratge";
$p2 = "mon";
$p3 = "politica";
$p4 = "societat";
$p5 = "economia";
$p6 = "falles";
$p7 = "magdalena";
$p8 = "fogueres";
$p9 = "societat";
$p10 = "futbol";
$p11 = "basquet";
$p12 = "poliesportiu";
$p13 = "pilota";
$p14 = "previsio";
$p15 = "l-oratge";
$p16 = "eleccions";

// paraules deles URL que vols evitar que apareguen en les publicacions (fins a XX )
$np0 = "notes-de-premsa";
$np1 = null;
$np2 = null;
$np3 = null;

// LOG o fitxer d'accions històriques
//$log_fitxer = "/var/log/mastodon_bot.log";
$log_fitxer = $lloc."/log/mastodon_bot.log";
//$log_fitxer = $lloc."/log/mastodon_bot.log";

// quantes linies vols incloure al registre? (Afecta al que ocuparà el fitxer .log)
// Pots triar entre CURT (el que figura), DETALLAT i COMPLET (Escriu en MAJÚSCULES)
$log_detall = "CURT";
//$log_detall = "DETALLAT";
//$log_detall = "COMPLET";


// **********************************************
// * Configuració d'enviament de correus d'avís *
// **********************************************
$act_correu  = 1;
$elmeucompte = "usuari@lloc.domini";
$elremitent  = "webmaster@lloc.domini";


// ****************************************
// * Configuració de Mastodon i font RSS: *
// * Clau del compte del bot a Mastodon.  *
// ****************************************
// Has de copiar el que et genera mastodon quan crees l'aplicació (primera linia)
$token="el que siga a mastodon";

// URL de la instància on està el compte (No escriure '/' al final.
$base_url="https://instancia.domini";

// id del teu compte (pots averiguar-lo mirant el codi font del teu perfil
$id_cmpt ="xxxxxxxxxxxxxxxxxxx";

// URL de la font RSS o Atom que vols que es publique
//$fitxer="https://www.apuntmedia.es/rss/";

// adreça web per citar la font (no cal que siga la del RSS)
$web_of = "https://www.xxxxxx.yyy/";
// multi microsites
// portada del web
//$fitxer0="https://www.apuntmedia.es/rss/";

// microsite de noticies
$fitxer0 = "https://www.xxxxxx.yyy/rss/";
// microsite esports
$fitxer1 = "https://www.xxxxxx.yyy/rss/";

$fitxer2 = "https://www.xxxxxx.yyy/rss/";
// lloc general rss
$fitxer3 = "https://www.xxxxxx.yyy/rss/";
// quantes fonts vols que es presenten? (1, 2 o 3 )
//$nom_fonts = 3;
$fitxers_nombre = 3;

//Les quatre opcions de la visib_tut dels toot son 'public' (per defecte), unlisted, private i directe.
$visib_tut="public";

// Si el valor escrit aquí es 3 i la teua opció de $visibility és "public", aleshores la visib_tut del toot serà "public" cada tres toots.
// La resta de toots seran "unlisted" per defecte. Si el valor és 1, significa que la visib_tut serà sempre la del valor de $visib_tut
$public_freq = 4;

// defineix la llengua de la publicació
// ca per al català, en per a l'angles, zh per al xinés, etc.
$llengua="ca";

// Configuració de la zona horaria
header('Content-Type: text/html; charset=utf-8');
if (!ini_get('date.timezone')) {
	date_default_timezone_set('Europe/Madrid');
}

// NO CAL TOCAR RES A PARTIR D'ESTA LÍNIA
// Qualsevol canvi serà al seu risc ja que estan provades que tal i com estan funciona.

$headers = [
  "Authorization: Bearer " . $token
];

// registres que presentarà en consultar els nous seguidors
$limit_b = 20;
// registres que presentarà en consultar les mencions
$limit_m = 26;
// registres que presentarà en consultar els reblocs i favorits
$limit_i = 28;

// registres que presentarà en consultar les mencions per fer la benvinguda als seguidors
$limit_s = 30;

// nombre de linies del fitxer de dates
$max_linies = 420;
// diferencia de linies amb el fitxer de urls
$max_linies_ad = 60;

// Final de la configuració. No cal tocar cap altre fitxer.
$bot_nom   = "bot_plus";
$bot_versio  = "0.X.Xβ";

?>
